#include "state.h"
#include "libmy/gbfs.h"
#include "libmy/mode3.h"
#include "libmy/debug.h"


//---------------------------------------------------------------------------
u16 StateAct;
u16 StateBpeCnt;
u16 StateLz77Cnt;


//---------------------------------------------------------------------------
EWRAM_CODE void StateInit(void)
{
	StateAct = 0;

	StateBpeCnt  = 0;
	StateLz77Cnt = 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateExec(void)
{
	u8* pImg;
	u32 size;

	switch(StateAct)
	{
	// Bpe
	case 0:
		DebugSetVblankCnt(0);

		pImg = GbfsGetSafePointer("bpe.bpe");
		size = GbfsGetFileSize();
		Mode3DrawFullBpe(pImg, size);

		StateBpeCnt = DebugGetVblankCnt();
		StateAct++;
		break;

	// Lz77
	case 1:
		DebugSetVblankCnt(0);

		pImg = GbfsGetSafePointer("lz77.img");
//		size = GbfsGetFileSize();
		Mode3DrawFullLz77((u16*)pImg);

		StateLz77Cnt = DebugGetVblankCnt();
		StateAct++;
		break;

	// RESULT
	case 2:
		Mode3DrawStrLf("REG_VCOUNT");
		Mode3DrawStr("BPE:  ");
		Mode3DrawNumLf(StateBpeCnt);

		Mode3DrawStr("LZ77: ");
		Mode3DrawNumLf(StateLz77Cnt);

		StateAct++;
		break;

	// EMPTY
	case 3:
		break;
	}
}
