#include "bpe.h"


//---------------------------------------------------------------------------
ST_BPE Bpe;


//---------------------------------------------------------------------------
int main(int argc, char* argv[])
{
	BpeInit();
	BpeSetArg(argc, argv);

	BpeExec();

	return 0;
}
//---------------------------------------------------------------------------
void BpeInit(void)
{
	memset(&Bpe, 0x00, sizeof(ST_BPE));

	Bpe.bufSize = BPE_BUF_DEFAULT_SIZE;
}
//---------------------------------------------------------------------------
void BpeUsage(void)
{
	printf(" : bpe [IvV] ̓t@C [o̓t@C]\n");
	printf("IvV : -d ... \n");
	printf("             -e ... k\n");
	printf("             -bn ... obt@TCYi n = %d ` %d )\n", BPE_BUF_MIN_SIZE, BPE_BUF_MAX_SIZE);
	printf("                     (ftHg : %d)\n", Bpe.bufSize);

	exit(2);
}
//---------------------------------------------------------------------------
void BpeError(char* msg)
{
	fprintf(stderr, "%s\n", msg);

	exit(1);
}
//---------------------------------------------------------------------------
void BpeSetArg(int argc, char* argv[])
{
	s32 fileSelCnt = 0;
	s32 i;

	for(i=1; i<argc; i++)
	{
		if(argv[i][0] == '-')
		{
			char opt = toupper(argv[i][1]);

			switch (opt)
			{
			case 'E':
				Bpe.mode = BPE_MODE_ENCODE;
				break;

			case 'D':
				Bpe.mode = BPE_MODE_DECODE;
				break;

			case 'B':
				Bpe.bufSize = atoi(&(argv[i][2]));
				break;

			case '?':
				BpeUsage();
				break;

			default:
				BpeError("sȃIvVł");
				break;
			}
		}
		else if(fileSelCnt == 0)
		{
			fileSelCnt++;
			strncpy(Bpe.fnameSrc, argv[i], FILENAME_MAX);
		}
		else if(fileSelCnt == 1)
		{
			fileSelCnt++;
			strncpy(Bpe.fnameDst, argv[i], FILENAME_MAX);
		}
	}


	if(Bpe.mode == BPE_MODE_NONE)
	{
		BpeUsage();
	}

	if(Bpe.bufSize < BPE_BUF_MIN_SIZE || BPE_BUF_MAX_SIZE < Bpe.bufSize)
	{
		BpeError("obt@̃TCYsł");
	}

	if(fileSelCnt == 0)
	{
		BpeError("͂̃t@C܂");
	}


	if(fileSelCnt == 1)
	{
		strncpy(Bpe.fnameDst, Bpe.fnameSrc, FILENAME_MAX);

		if(Bpe.mode == BPE_MODE_DECODE)
		{
			strncat(Bpe.fnameDst, ".tst", FILENAME_MAX);
		}
		else
		{
			strncat(Bpe.fnameDst, ".bpe", FILENAME_MAX);
		}
	}
}
//---------------------------------------------------------------------------
void BpeExec(void)
{
	printf("bpe %s(%d)... %s\n", (Bpe.mode == BPE_MODE_ENCODE) ? "encode" : "decode", Bpe.bufSize, Bpe.fnameSrc);

	if(Bpe.mode == BPE_MODE_ENCODE)
	{
		BpeExecEncode();
	}
	else
	{
		BpeExecDecode();
	}
}
//---------------------------------------------------------------------------
void BpeExecEncode(void)
{
	FILE* fpIn  = fopen(Bpe.fnameSrc, "rb");
	FILE* fpOut = fopen(Bpe.fnameDst, "wb");

	if(fpIn == NULL)
	{
		BpeError("̓t@C܂");
	}

	if(fpOut == NULL)
	{
		BpeError("o̓t@CI[vɎs܂");
	}


	s32 srcSize;
	s32 dstSize;

	for(;;)
	{
		srcSize = fread(Bpe.workBuf, 1, Bpe.bufSize, fpIn);

		if(srcSize <= 0)
		{
			break;
		}


		Bpe.pairCnt = 0;
		dstSize = BpeExecEncodeSub(srcSize);


		if(Bpe.pairCnt == 0)
		{
			// kȂ
			fputc(0x00, fpOut);

			fputc((dstSize  & 0xff), fpOut);
			fputc((dstSize >>    8), fpOut);

			fwrite(Bpe.workBuf, 1, dstSize, fpOut);
		}
		else
		{
			// k
			fputc(0x80, fpOut);

			fputc((dstSize  & 0xff), fpOut);
			fputc((dstSize >>    8), fpOut);

			fputc(Bpe.pairCnt, fpOut);
			fwrite(Bpe.pairBuf, 1, Bpe.pairCnt * 3, fpOut);

			fwrite(Bpe.workBuf, 1, dstSize, fpOut);
		}
	}

	fclose(fpIn);
	fclose(fpOut);
}
//---------------------------------------------------------------------------
s32 BpeExecEncodeSub(s32 size)
{
	s32  i;
	u8   ch;
	u8   c1, c2;

	s32  rpos;
	s32  wpos;

	s32  tmpCnt;
	s32  maxCnt;
	u8   maxC1, maxC2;

	s32  pairCnt;
	bool pairMap1[256];
	u8   pairMap2[256*256];


	// gpς݃CfbNX\ɂ܂
	for(i=0; i<256; i++)
	{
		pairMap1[i] = FALSE;
	}

	for(i=0; i<size; i++)
	{
		pairMap1[ Bpe.workBuf[i] ] = TRUE;
	}

	for(;;)
	{
		// gpĂȂ̃CfbNX߂܂
		for(i=0; i<256; i++)
		{
			if(pairMap1[i] == FALSE)
			{
				break;
			}
		}

		if(i == 256)
		{
			break;
		}
		ch = i;

		// ł悭oĂyA܂
		for(i=0; i<256*256; i++)
		{
			pairMap2[i] = 0x00;
		}

		maxCnt = 0;

		for(i=0; i<size-1; i+=2)
		{
			c1 = Bpe.workBuf[i+0];
			c2 = Bpe.workBuf[i+1];

			tmpCnt = ++pairMap2[ c1 | (c2 << 8) ];

			if(maxCnt < tmpCnt)
			{
				maxCnt = tmpCnt;
				maxC1  = c1;
				maxC2  = c2;
			}
		}

		if(maxCnt < 4)
		{
			break;
		}

		// yAchɒu܂
		rpos = 0;
		wpos = 0;

		while(rpos < size-1)
		{
			if(Bpe.workBuf[rpos] == maxC1 && Bpe.workBuf[rpos+1] == maxC2)
			{
				Bpe.workBuf[wpos++] = ch;
				rpos += 2;
			}
			else
			{
				Bpe.workBuf[wpos++] = Bpe.workBuf[rpos++];
			}
		}

		// rpos̈ʒuŌ1̏ꍇ
		if(rpos == size-1)
		{
			Bpe.workBuf[wpos++] = Bpe.workBuf[rpos++];
		}
		size = wpos;


		// chƃyA\ɓo^܂
		Bpe.pairBuf[Bpe.pairCnt * 3 + 0] = ch;
		Bpe.pairBuf[Bpe.pairCnt * 3 + 1] = maxC1;
		Bpe.pairBuf[Bpe.pairCnt * 3 + 2] = maxC2;
		Bpe.pairCnt++;

		pairMap1[ch] = TRUE;

	} // for(;;)


	return size;
}
//---------------------------------------------------------------------------
void BpeExecDecode(void)
{
	FILE* fpIn  = fopen(Bpe.fnameSrc, "rb");
	FILE* fpOut = fopen(Bpe.fnameDst, "wb");

	if(fpIn == NULL)
	{
		BpeError("̓t@C܂");
	}

	if(fpOut == NULL)
	{
		BpeError("o̓t@CI[vɎs܂");
	}


	// G[`FbNȂĂ܂BNbV̋ꂠ

	u8  stackBuf[256];
	u8  stackHead = 0;

	u8  pair1[256];
	u8  pair2[256];

	s32 c1, c2, c3, c4;
	s32 size;
	s32 rpos;
	s32 i;

	for(;;)
	{
		c1 = fgetc(fpIn);

		if(c1 == EOF)
		{
			break;
		}

		c2 = fgetc(fpIn);
		c3 = fgetc(fpIn);
		size = c2 | (c3 << 8);


		rpos = 0;

		// kȂ
		if(c1 == 0x00)
		{
			while(rpos < size)
			{
				c1 = fgetc(fpIn);
				rpos++;

				fputc(c1, fpOut);
			}

			continue;
		}


		// k
		for(i=0; i<256; i++)
		{
			pair1[i] = i;
			pair2[i] = 0x00;
		}

		c1 = fgetc(fpIn);

		for(i=0; i<c1; i++)
		{
			c2 = fgetc(fpIn);
			c3 = fgetc(fpIn);
			c4 = fgetc(fpIn);

			pair1[c2] = c3;
			pair2[c2] = c4;
		}

		while(rpos < size || stackHead > 0)
		{
			if(stackHead == 0)
			{
				c1 = fgetc(fpIn);
				rpos++;
			}
			else
			{
				c1 = stackBuf[--stackHead];
			}

			for(;;)
			{
				if(pair1[c1] == c1)
				{
					fputc(c1, fpOut);
					break;
				}

				stackBuf[stackHead++] = pair2[c1];
				c1 = pair1[c1];
			}
		}

	} // for(;;)


	fclose(fpIn);
	fclose(fpOut);
}
