#ifndef __BPE_H__
#define __BPE_H__


#include "gba.h"

//---------------------------------------------------------------------------
#define BPE_BUF_MIN_SIZE					128
#define BPE_BUF_MAX_SIZE					32767
#define BPE_BUF_DEFAULT_SIZE				4096


//---------------------------------------------------------------------------

enum {
	BPE_MODE_NONE = 0x00,
	BPE_MODE_ENCODE,
	BPE_MODE_DECODE,
};


typedef struct {
	u16  mode;

	char fnameSrc[FILENAME_MAX];
	char fnameDst[FILENAME_MAX];

	s32  bufSize;

	u8   workBuf[BPE_BUF_MAX_SIZE + 16];

	s32  pairCnt;
	u8   pairBuf[256 * 3];
} ST_BPE;


//---------------------------------------------------------------------------
void BpeInit(void);
void BpeUsage(void);
void BpeError(char* msg);
void BpeSetArg(int argc, char* argv[]);

void BpeExec(void);
void BpeExecEncode(void);
s32  BpeExecEncodeSub(s32 size);
void BpeExecDecode(void);


#endif
